package com.nisum.webfluxpractice.controllerWebClient;

import com.nisum.webfluxpractice.model.Student;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

public class StudentControllerWebClient {

    @Autowired
    private WebClient.Builder webClientBuilder;

    public Flux<Student> findAll() {
        return webClientBuilder.build()
                .get()
                .uri("http://localhost:8080/api/students")
                .retrieve()
                .bodyToFlux(Student.class);
    }

    public Mono<Student> create(Student s) {
        return webClientBuilder.build()
                .post()
                .uri("http://localhost:8080/api/students")
                .body(Mono.just(s), Student.class)
                .retrieve()
                .bodyToMono(Student.class);
    }

    public Mono<Student> update(Student s) {
        return webClientBuilder.build()
                .put()
                .uri("http://localhost:8080/api/students" + s.getId())
                .body(Mono.just(s), Student.class)
                .retrieve()
                .bodyToMono(Student.class);
    }

    public Mono<Void> delete(Integer id) {
        return webClientBuilder.build()
                .delete()
                .uri("http://localhost:8080/api/students/" + id)
                .retrieve()
                .bodyToMono(Void.class);
    }
}
