package com.nisum.webfluxpractice.service;

import com.nisum.webfluxpractice.model.Student;
import com.nisum.webfluxpractice.repository.StudentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class StudentService {

    @Autowired
    StudentRepository studentRepository;

    public void create(Student student) {
        studentRepository.save(student).subscribe();
    }

    public Mono<Student> findById(Integer id) {
        return studentRepository.findById(id);
    }

    public Flux<Student> findAll() {
        return studentRepository.findAll();
    }

    public Mono<Student> update(Student student) {
        return studentRepository.save(student);
    }

    public Mono<Void> delete(Integer id) {
        return studentRepository.deleteById(id);
    }
}
